/*

Copyright 2011 Danilo Ruffolo <danilo.ruffolo@gmail.com>

This file is part of nTetris.

nTetris is free software: you can redistribute it and/or
modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

nTetris is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with nTetris.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include "gioco.h"

Gioco::Gioco()
{
}

int Gioco::gestioneCaduta(Interfaccia& interfaccia, Schermo& schermo, Pezzo* p, Pezzo* prossimoP, int& riga, int& colonna)
{
    for (int i = 0; i < 100; i++)
    {
        usleep(10000-965*(schermo.getLivello()-1));
        comando = getch();
        switch(comando)
        {
        case KEY_LEFT:
            schermo.muoviSx(p, riga, colonna);
            break;
        case KEY_RIGHT:
            schermo.muoviDx(p, riga, colonna);
            break;
        case KEY_DOWN:
            schermo.muoviGiu(p, riga, colonna);
            break;
        case KEY_UP:
            schermo.ruotaPezzo(p, riga, colonna);
            break;
        case ' ':
            return interfaccia.menuPausa(schermo, p, prossimoP, riga, colonna);
        case '\n':
            return interfaccia.menuPausa(schermo, p, prossimoP, riga, colonna);
        }
    }
    return 0;
}

int Gioco::loopGioco(Interfaccia& interfaccia, Schermo& schermo, Tabellone& tabellone, Pezzo* pezzo, Pezzo* prossimoPezzo, int& riga, int& colonna)
{
    prossimoPezzo->stampaPezzo(5, 18);
    
    while(true)
    {
        pezzo->stampaPezzo(riga, colonna);
        switch(gestioneCaduta(interfaccia, schermo, pezzo, prossimoPezzo, riga, colonna))
        {
        case 0:
            break;
        case 1:
            return 1;
        case 2:
            return 0;
        case 3:
            return 2;
        }
        
        riga++;
        
        if(schermo.contatto(pezzo->getForma(pezzo->getFormaAttuale()), riga, colonna))
        {
            schermo.scolpisciPezzo(pezzo->getForma(pezzo->getFormaAttuale()), riga-1, colonna);
            for(int j = 1; j < 11; j++)
            {
                if(schermo.getCasella(3, j) > 0)
                {
                    interfaccia.fineGioco(schermo, tabellone);
                    return 2;
                }
            }
            schermo.gestioneLinee();
            prossimoPezzo->cancellaProssimoPezzo();
            return 0;
        }
        pezzo->cancellaPezzo(riga-1, colonna);
    }
}
