/*

Copyright 2011 Danilo Ruffolo <danilo.ruffolo@gmail.com>

This file is part of nTetris.

nTetris is free software: you can redistribute it and/or
modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

nTetris is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with nTetris.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include "pezzoS.h"

PezzoS::PezzoS()
    : formaAttuale(0)
{
    // formeS[0], formeS[2]
    for(int i = 0; i < 4; i++)
        for (int j = 0; j < 4; j++)
        {
            if(i == 0 || i == 1)
                formeS[0].setPosizione(i, j, 0);
            if(i == 2)
            {
                if (j == 2 || j == 3)
                    formeS[0].setPosizione(i, j, 3);
                else
                    formeS[0].setPosizione(i, j, 0);
            }
            if (i == 3)
            {
                if(j == 0 || j == 3)
                    formeS[0].setPosizione(i, j, 0);
                else
                    formeS[0].setPosizione(i, j, 3);
            }
        }
    
    // formeS[1], formeS[3]   
    for(int i = 0; i < 4; i++)
        for (int j = 0; j < 4; j++)
        {
            if(j == 0 || j == 3)
                formeS[1].setPosizione(i, j, 0);
            if(j == 1)
            {
                if(i == 0 || i == 3)
                    formeS[1].setPosizione(i, j, 0);
                else
                    formeS[1].setPosizione(i, j, 3);
            }
            if(j == 2)
            {
                if(i == 2 || i == 3)
                    formeS[1].setPosizione(i, j, 3);
                else
                    formeS[1].setPosizione(i, j, 0);
            }
        }
}

const Forma& PezzoS::getForma(int forma) const
{
    if(forma == 0 || forma == 2)
        return formeS[0];
    else
        return formeS[1];
}

int PezzoS::getNumeroPezzo() const
{
    return 3;
}

int PezzoS::getFormaAttuale() const
{
    return formaAttuale;
}

int PezzoS::getMaxForme() const
{
    return 1;
}

void PezzoS::setFormaAttuale(int forma)
{
    if(forma == 0 || forma == 2)
        formaAttuale = 0;
    else
        formaAttuale = 1;
}
