/*

Copyright 2011 Danilo Ruffolo <danilo.ruffolo@gmail.com>

This file is part of nTetris.

nTetris is free software: you can redistribute it and/or
modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

nTetris is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with nTetris.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include "pezzoT.h"

PezzoT::PezzoT()
    : formaAttuale(0)
{
    // formeT[0]
    for(int i = 0; i < 4; i++)
        for (int j = 0; j < 4; j++)
        {
            if(i == 0 || i == 3)
                formeT[0].setPosizione(i, j, 0);
            if(i == 1)
            {
                if (j == 2)
                    formeT[0].setPosizione(i, j, 2);
                else
                    formeT[0].setPosizione(i, j, 0);
            }
            if (i == 2)
            {
                if(j == 0)
                    formeT[0].setPosizione(i, j, 0);
                else
                    formeT[0].setPosizione(i, j, 2);
            }
        }

    // formeT[1]
    for(int i = 0; i < 4; i++)
        for (int j = 0; j < 4; j++)
        {
            if(j == 0 || j == 1)
                formeT[1].setPosizione(i, j, 0);
            if(j == 2)
            {
                if(i == 0)
                    formeT[1].setPosizione(i, j, 0);
                else
                    formeT[1].setPosizione(i, j, 2);
            }
            if(j == 3)
            {
                if(i == 2)
                    formeT[1].setPosizione(i, j, 2);
                else
                    formeT[1].setPosizione(i, j, 0);
            }       
        }

    // formeT[2]
    for(int i = 0; i < 4; i++)
        for (int j = 0; j < 4; j++)
        {
            if(i == 0 || i == 1)
               formeT[2].setPosizione(i, j, 0);
            if(i == 2)
            {
                if(j == 0)
                    formeT[2].setPosizione(i, j, 0);
                else
                    formeT[2].setPosizione(i, j, 2);
            }
            if(i == 3)
            {
                if(j == 2)
                    formeT[2].setPosizione(i, j, 2);
                else
                    formeT[2].setPosizione(i, j, 0);
            }
        }

    // formeT[3]
    for(int i = 0; i < 4; i++)
        for (int j = 0; j < 4; j++)
        {
            if(j == 0 || j == 3)
                formeT[3].setPosizione(i, j, 0);
            if(j == 1)
            {
                if(i == 2)
                    formeT[3].setPosizione(i, j, 2);
                else
                    formeT[3].setPosizione(i, j, 0);
            }
            if(j == 2)
            {
                if(i == 0)
                    formeT[3].setPosizione(i, j, 0);
                else
                    formeT[3].setPosizione(i, j, 2);
            }
        }
}

const Forma& PezzoT::getForma(int forma) const
{
    return formeT[forma];
}

int PezzoT::getNumeroPezzo() const
{
    return 2;
}

int PezzoT::getFormaAttuale() const
{
    return formaAttuale;
}

int PezzoT::getMaxForme() const
{
    return 3;
}

void PezzoT::setFormaAttuale(int forma)
{
    formaAttuale = forma;
}
