/*

Copyright 2011 Danilo Ruffolo <danilo.ruffolo@gmail.com>

This file is part of nTetris.

nTetris is free software: you can redistribute it and/or
modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

nTetris is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with nTetris.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include "pezzoZ.h"

PezzoZ::PezzoZ()
    : formaAttuale(0)
{
    // formeZ[0], formeZ[2]
    for(int i = 0; i < 4; i++)
        for(int j = 0; j < 4; j++)
        {
            if(i == 0 || i == 1)
                formeZ[0].setPosizione(i, j, 0);
            if(i == 2)
            {
                if(j == 0 || j == 3)
                    formeZ[0].setPosizione(i, j, 0);
                else
                    formeZ[0].setPosizione(i, j, 6);
            }
            if(i == 3)
            {
                if(j == 0 || j == 1)
                    formeZ[0].setPosizione(i, j, 0);
                else
                    formeZ[0].setPosizione(i, j, 6);
            }
        }
    
    // formeZ[1], formeZ[3]
    for(int i = 0; i < 4; i++)
        for(int j = 0; j < 4; j++)
        {
            if(j == 0 || j == 3)
                formeZ[1].setPosizione(i, j, 0);
            if(j == 1)
            {
                if(i == 0 || i == 1)
                    formeZ[1].setPosizione(i, j, 0);
                else
                    formeZ[1].setPosizione(i, j, 6);
            }
            if(j == 2)
            {
                if(i == 0 || i == 3)
                    formeZ[1].setPosizione(i, j, 0);
                else
                    formeZ[1].setPosizione(i, j, 6);
            }
        }
}

const Forma& PezzoZ::getForma(int forma) const
{
    if(forma == 0 || forma == 2)
        return formeZ[0];
    else
        return formeZ[1];
}

int PezzoZ::getNumeroPezzo() const
{
    return 6;
}

int PezzoZ::getFormaAttuale() const
{
    return formaAttuale;
}

int PezzoZ::getMaxForme() const
{
    return 1;
}

void PezzoZ::setFormaAttuale(int forma)
{
    if(forma == 0 || forma == 2)
        formaAttuale = 0;
    else
        formaAttuale = 1;
}
